# Class ProtoMessageRequestFormatter&lt;RequestT&gt; (2.81.0)

2.81.0 (latest) 2.80.0 2.79.0 2.76.0 2.75.0 2.74.1 2.73.1 2.72.2 2.71.0 2.70.3 2.69.0 2.68.2 2.67.0 2.66.0 2.65.0 2.63.1 2.62.0 2.61.0 2.60.0 2.59.1 2.58.0 2.57.0 2.55.0 2.54.1 2.53.0 2.52.0 2.51.0 2.50.0 2.49.0 2.48.1 2.47.0 2.46.1 2.45.0 2.43.0 2.42.0 2.41.0 2.39.0 2.38.0 2.37.0 2.36.0 2.35.0 2.34.1 2.33.0 2.32.1 2.31.1 2.30.1 2.24.0 2.23.3 2.22.0 2.21.0 2.20.1 2.19.6 2.18.7 2.17.0 2.16.0 2.15.0 2.14.0 2.13.0 2.12.2 2.11.0 2.10.0 2.9.0 2.8.1 2.7.1

    public class ProtoMessageRequestFormatter<RequestT> implements HttpRequestFormatter<RequestT>

Creates parts of a HTTP request from a protobuf message.

## Inheritance

[java.lang.Object](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html) \> ProtoMessageRequestFormatter\<RequestT\>

## Implements

com.google.api.gax.httpjson.HttpRequestFormatter\<RequestT\>

## Inherited Members

[Object.clone()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#clone--) [Object.equals(Object)](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#equals-java.lang.Object-) [Object.finalize()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#finalize--) [Object.getClass()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#getClass--) [Object.hashCode()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#hashCode--) [Object.notify()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#notify--) [Object.notifyAll()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#notifyAll--) [Object.toString()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#toString--) [Object.wait()](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--) [Object.wait(long)](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-) [Object.wait(long,int)](https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-)

| ## Type Parameter ||
|---|---|
| **Name** | **Description** |
| `RequestT` |   |

## Static Methods

### \<RequestT\>newBuilder()

    public static ProtoMessageRequestFormatter.Builder<RequestT> <RequestT>newBuilder()

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/java/docs/reference/gax/latest/com.google.api.gax.httpjson.ProtoMessageRequestFormatter.Builder<RequestT>` |   |

## Methods

### getAdditionalPathTemplates()

    public List<PathTemplate> getAdditionalPathTemplates()

Additional (alternative) path templates for endpoint URL path.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.oracle.com/javase/8/docs/api/java/util/List.html<com.google.api.pathtemplate.PathTemplate>` |   |

### getPath(RequestT apiMessage)

    public String getPath(RequestT apiMessage)

Returns the relative URL path created from the path parameters from the given message. Attempts
to match the with the default PathTemplate. If there is not match, it attempts to match with
the templates in the additionalPathTemplates.

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `apiMessage` | `RequestT` Request object to extract fields from |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.oracle.com/javase/8/docs/api/java/lang/String.html` | Path of a matching valid URL or the default Path URL |

### getPathTemplate()

    public PathTemplate getPathTemplate()

Path template for endpoint URL path.

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `com.google.api.pathtemplate.PathTemplate` |   |

### getQueryParamNames(RequestT apiMessage)

    public Map<String,List<String>> getQueryParamNames(RequestT apiMessage)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `apiMessage` | `RequestT` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.oracle.com/javase/8/docs/api/java/util/Map.html<https://docs.oracle.com/javase/8/docs/api/java/lang/String.html,https://docs.oracle.com/javase/8/docs/api/java/util/List.html<https://docs.oracle.com/javase/8/docs/api/java/lang/String.html>>` |   |

### getRequestBody(RequestT apiMessage)

    public String getRequestBody(RequestT apiMessage)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `apiMessage` | `RequestT` |

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.oracle.com/javase/8/docs/api/java/lang/String.html` |   |

### toBuilder()

    public ProtoMessageRequestFormatter.Builder<RequestT> toBuilder()

| **Returns** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/java/docs/reference/gax/latest/com.google.api.gax.httpjson.ProtoMessageRequestFormatter.Builder<RequestT>` |   |